#!/usr/bin/perl -w
#

use warnings;
use strict;
use Getopt::Long;

my %options = ();
my $ZONEDIR = "/usr/share/zoneinfo/";
my $CLOCKFILE = "/etc/sysconfig/clock";
my $TMPCLOCKFILE = "/tmp/tmpClock";
my $COMMAND = "/opt/ibm/director/vmi/scripts/execWithPrivilege/dateTimeUtil";

if (! (GetOptions (\%options, 'date=s', 'time=s','timezone=s'))) {
    exit (1); 
}


# to set timezone, we need to link the timezone file in /usr/share/zoneinfo by calling dateTimeUtil script and replace the ZONE line in /etc/sysconfig/clock 
if (defined $options{'timezone'}){
    my $newZone = $options{'timezone'};
    
    my $newZoneFile = $ZONEDIR.$newZone;

    #link timezone file
    if (system "$COMMAND -c linkZone -f $newZoneFile") {
        print "Link timezone file failed!\n";
	exit(1);
    }
    #replace TIMEZONE line in /etc/sysconfig/clock
    open FILE, $CLOCKFILE or die "Can't open '$CLOCKFILE': $!";
    open TMPFILE, ">$TMPCLOCKFILE" or die "Can't open tmp clock file";
    while(<FILE>){
	 s/\bTIMEZONE=.*/TIMEZONE=\"$newZone"/; 
	 print TMPFILE $_;
    }
    close FILE;
    close TMPFILE;
    if (system "$COMMAND -c copyClock -f $TMPCLOCKFILE") {
        print "copy clock file failed!\n";
	exit(1);
    }
}

if(defined $options{'date'}){
    my $newDate = $options{'date'};
    my $newTime = "00:00:00";
    if(defined $options{'time'}){
	    $newTime=$options{'time'};
    }
    #call dateTimeUtil to set the new date
    if (system "$COMMAND -c setDateTime -d $newDate -t $newTime -k --utc"){
	    print "set date time failed!\n";
	    exit(1);
    }
}
