#!/usr/bin/perl -w
# %Z%%M%------- %I%- %W% %G% %U% 

use warnings;
use strict;
use Getopt::Long;

my %options = ();
my $RESOLVFILE = "/etc/resolv.conf";


if (! (GetOptions (\%options, 'dnsserver=s', 'domainsuffix=s'))) {
    exit (1); 
}
print "AE: DNS server configuration\n";
if(!defined $options{'dnsserver'} && !defined $options{'domainsuffix'} ){
    print "AE: Not all options specified.\n";
    exit 1;
}

if (! defined $options{'dnsserver'}) {
    $options{'dnsserver'} = "";
}

if (! defined $options{'domainsuffix'}) {
    $options{'domainsuffix'} = "";
}

print "AE: setting DNS server to \"$options{dnsserver}\" and domain suffix to \"$options{domainsuffix}\" ...\n";
my $nameservers=$options{'dnsserver'};
my @nameservers=();
if ($nameservers =~ /,/){
    @nameservers=split /,/,$nameservers;
}
else{
    @nameservers=($nameservers);
}
# the maximum number of nameserver is 3
if( @nameservers > 3 ) {
    print "AE: more than 3 nameserver specified, only the first 3 nameservers will be kept.\n";
    @nameservers =($nameservers[0], $nameservers[1], $nameservers[2]);
}

$options{'domainsuffix'} =~ y/,/ /;
my $result="search $options{'domainsuffix'}\n";
foreach my $ns (@nameservers) {
    $result.= "nameserver $ns\n";
}
open FILE, "> $RESOLVFILE" or die "AE: canot open $RESOLVFILE to write\n";
print FILE $result;
close FILE;
print "AE: DNS server configuration completed.\n";
exit 0;

