# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2010, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
# IBM_COPYRIGHT_END

# 
# 09N6996

crt_cim_rsrcs () {

    lsrg -A d -g $CIM_RG &>/dev/null
    if [ $? -eq 6 ]; then
	
	    # create the resource group
        mkrg $CIM_RG
        chrg_l_none $CIM_RG

        crt_cim_rsrc cimserverd
        crt_cim_rsrc cimlistenerd
        if [ -e /etc/init.d/ibmsa ]; then
            crt_cim_rsrc ibmsa
        else
            crt_cim_rsrc paslpd
        fi
        crt_cim_rsrc tier1slpinst

        crt_cim_dep
        
        sleep 5
        #chrg -o online $CIM_RG
        debug "tsa call hook 1"
        call_tsa_chrg_o_l_u -o online $CIM_RG


    else
        debug "cim resources already created"   
    fi  
	
}

crt_cim_rsrc () {
	   local cim_name=${1}
    
       local rsrc=${CIM_RSRC_NAME}-${cim_name}
       debug "Create the $rsrc resource"
       mkrsrc IBM.Application \
       Name="$rsrc" \
       StartCommand="$CIM_MONITOR_SCRIPT start $cim_name" \
       StopCommand="$CIM_MONITOR_SCRIPT stop $cim_name" \
       MonitorCommand="$CIM_MONITOR_SCRIPT status $cim_name" \
       MonitorCommandPeriod=$CIM_MON_CMD_PERIOD \
       MonitorCommandTimeout=$CIM_MON_CMD_TIMEOUT \
       NodeNameList="{'$HOST','$node'}" \
       StartCommandTimeout=$CIM_MON_START_TIMEOUT \
       StopCommandTimeout=$CIM_MON_STOP_TIMEOUT \
       UserName="root" \
       ResourceType=2
        
       # add to the resource group
       add_to_rg $rsrc IBM.Application $CIM_RG 
}


crt_cim_dep () {
    local slpd=paslpd
    
    if [ -e /etc/init.d/ibmsa ]; then
        slpd=ibmsa
    fi
	
	debug "Make the cim dependencies"
    make_relationship DependsOn IBM.Application:${CIM_RSRC_NAME}-cimserverd \
            IBM.Application:${CIM_RSRC_NAME}-$slpd \
            ${CIM_RSRC_NAME}-cimserverd-depon-${CIM_RSRC_NAME}-$slpd
            
    make_relationship DependsOn IBM.Application:${CIM_RSRC_NAME}-tier1slpinst \
            IBM.Application:${CIM_RSRC_NAME}-$slpd \
            ${CIM_RSRC_NAME}-tier1slpinst-depon-${CIM_RSRC_NAME}-$slpd
            
}


restart_cim_services () {
	
    /etc/init.d/paslpd start
    sleep 3
    /etc/init.d/cimlistenerd start
    /etc/init.d/cimserverd start
    /etc/init.d/tier1slpinst start
	
}
