# Licensed Materials - Property of IBM
#
# 09N6996
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

PROGNAME=$(basename $0)
PROGPATH=$(dirname $0)
#### Use a special path for TSA monitoring scripts
PATH=/bin:/usr/bin:/sbin:/usr/sbin:/usr/sbin/rsct/bin
export PATH

#### Standard code to find an pull in all sm common code ####
# Use the specified path to this command, then working directory, then path
PATH=$PROGPATH:`pwd`:$PATH
CMDFINDER=which
CMD_DIR=`$CMDFINDER $PROGNAME`
CMD_DIR=`dirname $CMD_DIR`

COMMON_CODE=$CMD_DIR/../include/smhacommon.sh

if [ -f $COMMON_CODE ]; then
    source $COMMON_CODE
else
    echo "$PROGNAME:Common code not found."
    exit 1
fi
#############################################################

RSRC_ACTION=${1}        # start, stop, status
resource=${2}           # base, primary, mounted, sync
name=${3}               # disk label name, e.g. mirror0

case $resource in
    base)    RSRC_NAME=$SMHA_DRBDB_RSRC_NAME ;;
    primary) RSRC_NAME=${_SMHA_DRBDP_RSRC_NAME_PFX}-${name} ;;
    mounted) RSRC_NAME=${_SMHA_DRBDM_RSRC_NAME_PFX}-${name} ;;
    sync)    RSRC_NAME=${_SMHA_DRBDS_RSRC_NAME_PFX}-${name} ;;
esac

load_common_code $INSTALL_DIR/ha/bin/test/smhatestcom.sh

case $RSRC_ACTION in
    start)
        # when base is started, make corresponding sync resources online
        if [ "$resource" = "base" -a $RC -eq 0 ]
        then
            echo "$TSA_ONLINE" > ${RSRC_DATA}/drbds-mirror0
            smha_debug_tsa "make ${RSRC_DATA}/drbds-mirror0 online"

            echo "$TSA_ONLINE" > ${RSRC_DATA}/drbds-updateslib
            smha_debug_tsa "make ${RSRC_DATA}/drbds-updateslib online"
        fi
    ;;

    stop)
        # when base is stopped, make corresponding sync resources offline
        if [ "$resource" = "base" -a $RC -eq 0 ]
        then
            echo "$TSA_OFFLINE" > ${RSRC_DATA}/drbds-mirror0
            smha_debug_tsa  "make ${RSRC_DATA}/drbds-mirror0 offline"

            echo "$TSA_OFFLINE" > ${RSRC_DATA}/drbds-updateslib
            smha_debug_tsa  "make ${RSRC_DATA}/drbds-updateslib offline"
        fi
    ;;
esac

exit $RC
# RC set in smhatestcom.sh

exit $RC
