# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2009, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

function getdisk(num) {
    cmd = VMI_BIN "/getDisk -n " num
    (cmd) | getline name
    close(cmd)
    return name
}

function sparetest(field) {
  if (nosp == "y") {
    # Match lines that are spare, when we are asking for spare or
    # Match lines that are not spare, when we are not asking for spare
    # Always exclude lines that are nosp
    return ((match(field, /spare/) && spare == "y") ||
          (!match(field, /spare/) && spare != "y") &&
          (!match(field, /nosp/)) ||
           both == "y")
  } else {
    # Match lines that are spare, when we are asking for spare or
    # Match lines that are not spare, when we are not asking for spare
    # Always include lines that are nosp
    return ((match(field, /spare/) && spare == "y") ||
            (!match(field, /spare/) && spare != "y") ||
            (match(field, /nosp/)) ||
             both == "y")
  }
}

BEGIN {
  FS=":"
  VMI_BIN="/opt/ibm/vmi/bin"

  split(v, args)
  spare = args[1]
  nosp = args[2]
  both = "n"
}

/^#/ { 
  next
}


$1 ~ /part/ && $6 ~ /drbd/ {
  if (sparetest($6)) {
    disk=getdisk($2)
    print "/dev/" disk $3 " " $4
  }
  next
}
