#!/usr/bin/perl -w
# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2009, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.


#This module acts as a utility interface to the login.defs file
 
use strict;
package lib::Login;

my $logindefs = "/etc/login.defs";

sub get_min_password_length() {
	my $ret = -1;
	
	my $command = sprintf("%s %s %s", "/bin/grep ^PASS_MIN_LEN", $logindefs, "| cut -f2");
    $ret = `$command`;
    
    return $ret; 
}

sub get_max_password_days() {
	   my $ret = -1;
    
    my $command = sprintf("%s %s %s", "/bin/grep ^PASS_MAX_DAYS", $logindefs, "| cut -f2");
    $ret = `$command`;
    
    return $ret;
}

sub get_current_login_id() {
	my $ret = getlogin();
	return $ret;
}
1;