# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2009, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

function isort(array, len) {
  for (i = 2; i < len; i++) {
    value = array[i]

    for (j = i - 1; j >= 1 && compare(array[j], value); j--) {
      array[j + 1] = array[j]
      array[j] = value;
    }
  }
}

# comparision function is confusing
# pri0 higher priority pri1 higher than pri2
# see variables in BEGIN section
# drives with shorter length is higher priority.
# i.e. vdb is higher priority than vdaa
# drives earlier in the alphabet are higher priority
# i.e. hda is higher priority than hdc

# returns 1 if left is lower priority than right
# 1 also means we are swapping
function compare(left, right) {
  llen=length(left);
  rlen=length(right);
  lstr=substr(left, 0, 2);
  rstr=substr(right, 0, 2);

  rc=comp_drive(lstr, rstr) 
  
  # continue processing
  if (rc == 2) {
    # if the lens are equal sort alphabetically
    # b > a (returns 1 meaning a comes first)

    # if left is longer, return 1 (meaning lower priority)
    # else return 0
    if (llen == rlen) {
      rc=(left > right)
    } else if (llen > rlen) {
      rc=1
    } else {
      rc=0
    }
  }
  return rc
}

# compare drive type.  pri0 before pri1 before pri2
function comp_drive(l, r) {
  if (l == r) { 
    # equals means we need to continue processing
    return 2
  } else if (l == pri0) { 
    # vd is always first so return 0
    return 0
  } else if (l == pri1) {
    # comp_drive(pri1,pri0) = 1 (swap)
    return (r == pri0) ? 1 : 0 
  } else {
    # hd is always last always swap
    return 1
  }
}
   

BEGIN { 
  pri0="hd"
  pri1="sd"
  pri2="vd"
  s=split(v, drive, ":")
  isort(drive, s)

  # last entry is the number we are looking for
  num=drive[s]
  s--

  print drive[num]
}
