# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2011, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
# IBM_COPYRIGHT_END

#
# 09N6996
#

export CT_MANAGEMENT_SCOPE=2

_SMHA_LOG_DIR=/opt/ibm/director/ha/logs
_SMHA_LOG=${_SMHA_LOG_DIR}/smha.log
SMHA_LOG_VERBOSE=${SMHA_LOG_VERBOSE:-0}  # set default if not already set

SMHA_DEBUG=${SMHA_DEBUG:-0}            # set default if not already set
SMHA_DEBUG_TSA=${SMHA_DEBUG_TSA:-0}    # set default if not already set

# define status values returned by TSA monitoring scripts

# Static TSA status values
#0=unknown,1=online,2=offline,3=failed offline,4=stuck online,5=pending online,6=pending offline
TSA_UNKNOWN=0
TSA_ONLINE=1
TSA_OFFLINE=2
TSA_FAILED_OFFLINE=3
TSA_STUCK_ONLINE=4
TSA_PENDING_ONLINE=5
TSA_PENDING_OFFLINE=6

# The following variables define the names of the various IBM.Application resources
# created by Director HA. When automating exploiter resources, these names can be
# used to create dependency relationships.
#
# A resource name has the form SMHA_*_RSRC_NAME*
#
# Also defined are the names of the resources groups created by Director HA. These
# names can also be used to create dependency relationships.
#
# A resource group name has the form SMHA_*_RG
#

# CIM resource name definitions for resources in the IBM.Application resource class

SMHA_CIM_RG=cim-rg
_SMHA_CIM_RSRC_NAME_PFX=cim
SMHA_CIM_RSRC_NAME_SERVER=${_SMHA_CIM_RSRC_NAME_PFX}-cimserverd
SMHA_CIM_RSRC_NAME_LISTENER=${_SMHA_CIM_RSRC_NAME_PFX}-cimlistenerd
SMHA_CIM_RSRC_NAME_TIER1SLP=${_SMHA_CIM_RSRC_NAME_PFX}-tier1slpinst
SMHA_CIM_RSRC_NAME_PASLP=${_SMHA_CIM_RSRC_NAME_PFX}-paslpd
SMHA_CIM_RSRC_NAME_IBMSA=${_SMHA_CIM_RSRC_NAME_PFX}-ibmsa

# DB2 resource name definitions for resources in the IBM.Application resource class

_SMHA_DB2INST=db2inst1
_SMHA_DB2PART=0
SMHA_DB2_RG=db2_${_SMHA_DB2INST}_${_SMHA_DB2PART}-rg
SMHA_DB2_DB_RSRC_NAME=db2_${_SMHA_DB2INST}_${_SMHA_DB2PART}-rs

# DHCP resource name definitions for resources in the IBM.Application resource class

SMHA_DHCP_RG=dhcp-rg
SMHA_DHCP6_RG=dhcp6-rg
SMHA_DHCP_RSRC_NAME=dhcp
SMHA_DHCP6_RSRC_NAME=dhcp6

# Director resource name definitions for resources in the IBM.Application resource class

SMHA_DIRECTOR_RG=director-rg
SMHA_DIRECTOR_RSRC_NAME=director

SMHA_ADVANCED_MGR_RG_PRIORITY=45

# DRBD resource name definitions for resources in the IBM.Application resource class

SMHA_DRBD_RG=drbd-rg
SMHA_DRBDB_RSRC_NAME=drbdb

_SMHA_DRBDP_RSRC_NAME_PFX=drbdp
_SMHA_DRBDS_RSRC_NAME_PFX=drbds
_SMHA_DRBDM_RSRC_NAME_PFX=drbdm

SMHA_DRBDP_MIRROR0_RSRC_NAME=${_SMHA_DRBDP_RSRC_NAME_PFX}-mirror0
SMHA_DRBDS_MIRROR0_RSRC_NAME=${_SMHA_DRBDS_RSRC_NAME_PFX}-mirror0
SMHA_DRBDM_MIRROR0_RSRC_NAME=${_SMHA_DRBDM_RSRC_NAME_PFX}-mirror0

SMHA_DRBDP_UPDATESLIB_RSRC_NAME=${_SMHA_DRBDP_RSRC_NAME_PFX}-updateslib
SMHA_DRBDS_UPDATESLIB_RSRC_NAME=${_SMHA_DRBDS_RSRC_NAME_PFX}-updateslib
SMHA_DRBDM_UPDATESLIB_RSRC_NAME=${_SMHA_DRBDM_RSRC_NAME_PFX}-updateslib

# NTP resource name definitions for resources in the IBM.Application resource class

SMHA_NTP_RG=ntp-rg
SMHA_NTP_RSRC_NAME=ntp

# Apache resource name definitions for resources in the IBM.Application resource class

SMHA_APACHE_RG=apache-rg
SMHA_APACHE_RSRC_NAME=apache

# The following definitions specify event types passed to the event plug-in scripts
# in /opt/ibm/director/ha/plugins/tsa/m.event
#
# An event type has the form SMHA_EVENT_*

SMHA_EVENT_MIRRORED_STORAGE=${SMHA_DRBDM_MIRROR0_RSRC_NAME}

### Main Code ######################

source /opt/ibm/director/ha/bin/include/smhabasecode.sh

# generate an ID for grouping log messages generated by the calling process

_smha_gen_log_id       # generate an ID for log messages
